/**
 * GoCheapR: add-on module.
 */

"use strict";

const request = require("request").Request;

const searchUrl = 'http://xml.gocheapr.com/files/search.txt';
const couponUrl = 'http://xml.gocheapr.com/files/coupon.txt';

const storesUrl = 'http://xml.gocheapr.com/files/stores.txt';
const flightUrl = 'http://xml.gocheapr.com/files/flight.txt';
const hotelsUrl = 'http://xml.gocheapr.com/files/hotels.txt';
const rentalUrl = 'http://xml.gocheapr.com/files/rental.txt';
const promosUrl = 'http://xml.gocheapr.com/files/promos.txt';

const enginesUrl = 'http://xml.gocheapr.com/files/engines.txt';

var addon = {
  keywords: [],
  coupons: [],
  stores: [],
  flights: [],
  hotels: [],
  rentals: [],
  promos: [],
  engines: []
};

addon.init = function() {
  this.fetchData(searchUrl, 'keywords');
  this.fetchData(couponUrl, 'coupons');
  this.fetchData(storesUrl, 'stores');
  this.fetchData(flightUrl, 'flights');
  this.fetchData(hotelsUrl, 'hotels');
  this.fetchData(rentalUrl, 'rentals');
  this.fetchData(promosUrl, 'promos');
  this.fetchData(enginesUrl, 'engines');
}

addon.sendRequest = function(worker, url, method) {
  request({
    url: url,
    onComplete: function (response) {
      log('sendRequest: response = ' + response.text);
      worker.port.emit(method, response.text);
    }
  }).get();
};

addon.fetchData = function(url, key) {
  request({
    url: url,
    onComplete: function (response) {
      log('fetchData: response = ' + response.text);
      addon.setData(key, response.json);
    }
  }).get();
};

addon.setData = function (key, data) {
  if (key == 'keywords') {
    this.keywords = data;
  } else if (key == 'coupons') {
    this.coupons = data;
  } else if (key == 'stores') {
    this.stores = data;
  } else if (key == 'flights') {
    this.flights = data;
  } else if (key == 'hotels') {
    this.hotels = data;
  } else if (key == 'rentals') {
    this.rentals = data;
  } else if (key == 'promos') {
    this.promos = data;
  } else if (key == 'engines') {
    this.engines = data;
  }
};

exports.Addon = addon;

function log(message) {
  console.log('GoCheapR > ' + message);
}
