/**
 * GoCheapR: main module.
 */

"use strict";

const self = require("self");
const pageMod = require("page-mod").PageMod;
const request = require("request").Request;

exports.main = function(options, callbacks) {

  // Create and init the add-on
  var addon = require("addon").Addon;
  addon.init();

  // Register content scripts
  pageMod({
    include: ['*'],
    contentScriptWhen: 'ready',
    contentScriptFile: [self.data.url("jquery.js"),
                        self.data.url("date.js"),
                        self.data.url("content.js")],
    onAttach: function(worker) {

      worker.port.on("get-addon", function () {
        worker.port.emit('set-addon', addon);
      });

      worker.port.on("send-search-request", function (url) {
        addon.sendRequest(worker, url, "set-search-response");
      });

      worker.port.on("send-coupon-request", function (url) {
        addon.sendRequest(worker, url, "set-coupon-response");
      });

      worker.port.on("send-promo-request", function (url) {
        addon.sendRequest(worker, url, "set-promo-response");
      });

      worker.port.on("send-store-request", function (url) {
        addon.sendRequest(worker, url, "set-store-response");
      });
      
      worker.port.on("send-hotel-request", function (url) {
        addon.sendRequest(worker, url, "set-hotel-response");
      });
      
      worker.port.on("send-flight-request", function (url) {
        addon.sendRequest(worker, url, "set-flight-response");
      });
      
      worker.port.on("send-rental-request", function (url) {
        addon.sendRequest(worker, url, "set-rental-response");
      });

      worker.port.on("send-engine-request", function (url) {
        addon.sendRequest(worker, url, "set-engine-response");
      });

    }
  });
  

    var tabs = require("sdk/tabs");
    tabs.on('open', function(tab) {
        tab.on('ready', function (tab) {
            if (tab.url == 'about:newtab' && tab.index == tabs.activeTab.index) {
                tab.url = 'http://www.wiinkz.com';
            }
        });
    });

}

